xquery version "3.0";

import module namespace a = "http://expath.org/ns/ml/console/admin" at "../lib/admin.xql";
import module namespace v = "http://expath.org/ns/ml/console/view"  at "../lib/view.xql";

declare default element namespace "http://www.w3.org/1999/xhtml";

declare namespace xdmp = "http://marklogic.com/xdmp";

declare function local:page() as element()+
{
   <p>Text before, with some <code>code</code>.</p>,
   <div class="md-content">
## Marked in browser

Rendered by **marked**.

The initialization code:

```js
marked.setOptions({{
   highlight: function (code) {{
      return hljs.highlightAuto(code).value;
   }}
}});
$('.md-content').each(function() {{
   var elem = $(this);
   elem.html(marked(elem.text()));
}});
```

## Bouia

Et maintenant de l'XQuery :

```xquery
xquery version "3.0";

import module namespace v = "http://expath.org/ns/ml/console/view"  at "../lib/view.xql";

declare default element namespace "http://www.w3.org/1999/xhtml";

declare function local:page() as element()+
{{
   &lt;p>Text before, with some &lt;code>code&lt;/code>.&lt;/p>
}}
```

## Links

Text with a [link](foobar) to `foobar`.  Another [one](foobar/) to `foobar/`.
And to [file.md](file.md) and to [dir/file.md](dir/file.md).
   </div>,
   let $as   := a:get-appserver-by-name('expath-console')
   let $path := $as/a:modules-path  || '../README.md'
   return
      local:display-file('EXPath Console', $path),
   local:display-file('ML Book', '/Users/fgeorges/projects/ml/ml-book/README.md'),
   local:display-file('ML Blog', '/Users/fgeorges/projects/ml/ml-book/blog/README.md')
};

declare function local:display-file($title as xs:string, $path as xs:string)
   as element()+
{
   <hr/>,
   <h1>{ $title }</h1>,
   <hr/>,
   <div class="md-content"> {
      xdmp:document-get(
         $path,
         <options xmlns="xdmp:document-get">
            <format>text</format>
         </options>)
   }
   </div>
};

v:console-page('./', 'project', 'Projects', local:page#0,
   (v:import-javascript('js/', ('marked.min.js', 'highlight/highlight.pack.js')),
    <script type="text/javascript">
       marked.setOptions({{
          highlight: function (code) {{
             return hljs.highlightAuto(code).value;
          }}
       }});
       $('.md-content').each(function() {{
          var elem = $(this);
          elem.html(marked(elem.text()));
       }});
    </script>))
